/* A Bison parser, made by GNU Bison 2.7.  */

/* Bison implementation for Yacc-like parsers in C
   
      Copyright (C) 1984, 1989-1990, 2000-2012 Free Software Foundation, Inc.
   
   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.
   
   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
   
   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.
   
   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Bison version.  */
#define YYBISON_VERSION "2.7"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1




/* Copy the first part of user declarations.  */
/* Line 371 of yacc.c  */
#line 16 "gram.y"

#include "./dbpmda.h"
#include "./lex.h"

extern int stmt_type;

static union {
    pmID	whole;
    __pmID_int	part;
} pmid;

static union {
    pmInDom		whole;
    __pmInDom_int	part;
} indom;


static int	sts;
static int	inst;
static char	*str;
static char	warnStr[80];

param_t	param;

/*
 * pmidp may contain a dynamic PMID ... if so, ask the PMDA to
 * translate name if possible
 */
static int
fix_dynamic_pmid(char *name, pmID *pmidp)
{
    int		sts;
    __pmPDU	*pb;
    extern int	outfd;
    extern int	infd;
    extern pmdaInterface	dispatch;

    if (pmid_domain(*pmidp) == DYNAMIC_PMID && pmid_item(*pmidp) == 0) {
	if (connmode == CONN_DSO) {
	    if (dispatch.comm.pmda_interface >= PMDA_INTERFACE_4) {
		sts = dispatch.version.four.pmid(name, pmidp, dispatch.version.four.ext);
		if (sts < 0) return sts;
	    }
	}
	else if (connmode == CONN_DAEMON) {
	    sts = __pmSendNameList(outfd, FROM_ANON, 1, &name, NULL);
	    if (sts < 0) return sts;
	    sts = __pmGetPDU(infd, ANY_SIZE, TIMEOUT_NEVER, &pb);
	    if (sts < 0) return sts;
	    if (sts == PDU_PMNS_IDS) {
		int	xsts;
		sts = __pmDecodeIDList(pb, 1, pmidp, &xsts);
		__pmUnpinPDUBuf(pb);
		if (sts < 0) return sts;
		return xsts;
	    }
	    else if (sts == PDU_ERROR) {
		__pmDecodeError(pb, &sts);
		__pmUnpinPDUBuf(pb);
		return sts;
	    }
	}
    }
    return 0;
}



/* Line 371 of yacc.c  */
#line 137 "gram.tab.c"

# ifndef YY_NULL
#  if defined __cplusplus && 201103L <= __cplusplus
#   define YY_NULL nullptr
#  else
#   define YY_NULL 0
#  endif
# endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 0
#endif

/* In a future release of Bison, this section will be replaced
   by #include "gram.tab.h".  */
#ifndef YY_YY_GRAM_TAB_H_INCLUDED
# define YY_YY_GRAM_TAB_H_INCLUDED
/* Enabling traces.  */
#ifndef YYDEBUG
# define YYDEBUG 0
#endif
#if YYDEBUG
extern int yydebug;
#endif

/* Tokens.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
   /* Put the tokens into the symbol table, so that GDB and other debuggers
      know about them.  */
   enum yytokentype {
     NUMBER2D = 258,
     NUMBER3D = 259,
     NUMBER = 260,
     NEGNUMBER = 261,
     FLAG = 262,
     NAME = 263,
     PATHNAME = 264,
     MACRO = 265,
     STRING = 266,
     COMMA = 267,
     EQUAL = 268,
     OPEN = 269,
     CLOSE = 270,
     DESC = 271,
     GETDESC = 272,
     FETCH = 273,
     INSTANCE = 274,
     PROFILE = 275,
     HELP = 276,
     WATCH = 277,
     DBG = 278,
     QUIT = 279,
     STATUS = 280,
     STORE = 281,
     INFO = 282,
     TIMER = 283,
     NAMESPACE = 284,
     WAIT = 285,
     PMNS_NAME = 286,
     PMNS_PMID = 287,
     PMNS_CHILDREN = 288,
     PMNS_TRAVERSE = 289,
     ATTR = 290,
     DSO = 291,
     PIPE = 292,
     SOCK = 293,
     UNIX = 294,
     INET = 295,
     IPV6 = 296,
     ADD = 297,
     DEL = 298,
     ALL = 299,
     NONE = 300,
     INDOM = 301,
     ON = 302,
     OFF = 303,
     PLUS = 304,
     EOL = 305
   };
#endif
/* Tokens.  */
#define NUMBER2D 258
#define NUMBER3D 259
#define NUMBER 260
#define NEGNUMBER 261
#define FLAG 262
#define NAME 263
#define PATHNAME 264
#define MACRO 265
#define STRING 266
#define COMMA 267
#define EQUAL 268
#define OPEN 269
#define CLOSE 270
#define DESC 271
#define GETDESC 272
#define FETCH 273
#define INSTANCE 274
#define PROFILE 275
#define HELP 276
#define WATCH 277
#define DBG 278
#define QUIT 279
#define STATUS 280
#define STORE 281
#define INFO 282
#define TIMER 283
#define NAMESPACE 284
#define WAIT 285
#define PMNS_NAME 286
#define PMNS_PMID 287
#define PMNS_CHILDREN 288
#define PMNS_TRAVERSE 289
#define ATTR 290
#define DSO 291
#define PIPE 292
#define SOCK 293
#define UNIX 294
#define INET 295
#define IPV6 296
#define ADD 297
#define DEL 298
#define ALL 299
#define NONE 300
#define INDOM 301
#define ON 302
#define OFF 303
#define PLUS 304
#define EOL 305



#if ! defined YYSTYPE && ! defined YYSTYPE_IS_DECLARED
typedef union YYSTYPE
{
/* Line 387 of yacc.c  */
#line 85 "gram.y"

	char		*y_str;
	int		y_num;
	twodot_num      y_2num;
	threedot_num    y_3num;
	

/* Line 387 of yacc.c  */
#line 288 "gram.tab.c"
} YYSTYPE;
# define YYSTYPE_IS_TRIVIAL 1
# define yystype YYSTYPE /* obsolescent; will be withdrawn */
# define YYSTYPE_IS_DECLARED 1
#endif

extern YYSTYPE yylval;

#ifdef YYPARSE_PARAM
#if defined __STDC__ || defined __cplusplus
int yyparse (void *YYPARSE_PARAM);
#else
int yyparse ();
#endif
#else /* ! YYPARSE_PARAM */
#if defined __STDC__ || defined __cplusplus
int yyparse (void);
#else
int yyparse ();
#endif
#endif /* ! YYPARSE_PARAM */

#endif /* !YY_YY_GRAM_TAB_H_INCLUDED  */

/* Copy the second part of user declarations.  */

/* Line 390 of yacc.c  */
#line 316 "gram.tab.c"

#ifdef short
# undef short
#endif

#ifdef YYTYPE_UINT8
typedef YYTYPE_UINT8 yytype_uint8;
#else
typedef unsigned char yytype_uint8;
#endif

#ifdef YYTYPE_INT8
typedef YYTYPE_INT8 yytype_int8;
#elif (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
typedef signed char yytype_int8;
#else
typedef short int yytype_int8;
#endif

#ifdef YYTYPE_UINT16
typedef YYTYPE_UINT16 yytype_uint16;
#else
typedef unsigned short int yytype_uint16;
#endif

#ifdef YYTYPE_INT16
typedef YYTYPE_INT16 yytype_int16;
#else
typedef short int yytype_int16;
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif ! defined YYSIZE_T && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned int
# endif
#endif

#define YYSIZE_MAXIMUM ((YYSIZE_T) -1)

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(Msgid) dgettext ("bison-runtime", Msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(Msgid) Msgid
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YYUSE(E) ((void) (E))
#else
# define YYUSE(E) /* empty */
#endif

/* Identity function, used to suppress warnings about constant conditions.  */
#ifndef lint
# define YYID(N) (N)
#else
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static int
YYID (int yyi)
#else
static int
YYID (yyi)
    int yyi;
#endif
{
  return yyi;
}
#endif

#if ! defined yyoverflow || YYERROR_VERBOSE

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined EXIT_SUCCESS && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
      /* Use EXIT_SUCCESS as a witness for stdlib.h.  */
#     ifndef EXIT_SUCCESS
#      define EXIT_SUCCESS 0
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's `empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (YYID (0))
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined EXIT_SUCCESS \
       && ! ((defined YYMALLOC || defined malloc) \
	     && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef EXIT_SUCCESS
#    define EXIT_SUCCESS 0
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined EXIT_SUCCESS && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined EXIT_SUCCESS && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* ! defined yyoverflow || YYERROR_VERBOSE */


#if (! defined yyoverflow \
     && (! defined __cplusplus \
	 || (defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yytype_int16 yyss_alloc;
  YYSTYPE yyvs_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (yytype_int16) + sizeof (YYSTYPE)) \
      + YYSTACK_GAP_MAXIMUM)

# define YYCOPY_NEEDED 1

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)				\
    do									\
      {									\
	YYSIZE_T yynewbytes;						\
	YYCOPY (&yyptr->Stack_alloc, Stack, yysize);			\
	Stack = &yyptr->Stack_alloc;					\
	yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAXIMUM; \
	yyptr += yynewbytes / sizeof (*yyptr);				\
      }									\
    while (YYID (0))

#endif

#if defined YYCOPY_NEEDED && YYCOPY_NEEDED
/* Copy COUNT objects from SRC to DST.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(Dst, Src, Count) \
      __builtin_memcpy (Dst, Src, (Count) * sizeof (*(Src)))
#  else
#   define YYCOPY(Dst, Src, Count)              \
      do                                        \
        {                                       \
          YYSIZE_T yyi;                         \
          for (yyi = 0; yyi < (Count); yyi++)   \
            (Dst)[yyi] = (Src)[yyi];            \
        }                                       \
      while (YYID (0))
#  endif
# endif
#endif /* !YYCOPY_NEEDED */

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  107
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   209

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  51
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  13
/* YYNRULES -- Number of rules.  */
#define YYNRULES  105
/* YYNRULES -- Number of states.  */
#define YYNSTATES  191

/* YYTRANSLATE(YYLEX) -- Bison symbol number corresponding to YYLEX.  */
#define YYUNDEFTOK  2
#define YYMAXUTOK   305

#define YYTRANSLATE(YYX)						\
  ((unsigned int) (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[YYLEX] -- Bison symbol number corresponding to YYLEX.  */
static const yytype_uint8 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50
};

#if YYDEBUG
/* YYPRHS[YYN] -- Index of the first RHS symbol of rule number YYN in
   YYRHS.  */
static const yytype_uint16 yyprhs[] =
{
       0,     0,     3,     6,    13,    18,    22,    27,    32,    37,
      40,    43,    47,    50,    54,    57,    62,    65,    69,    74,
      77,    81,    86,    91,    94,    99,   104,   110,   116,   119,
     123,   126,   130,   133,   137,   140,   144,   147,   151,   155,
     158,   162,   167,   170,   174,   178,   182,   186,   190,   194,
     198,   202,   206,   210,   214,   218,   222,   226,   230,   234,
     238,   242,   246,   250,   254,   257,   260,   264,   268,   272,
     275,   278,   282,   286,   289,   293,   297,   300,   304,   306,
     307,   309,   311,   313,   314,   316,   318,   320,   322,   324,
     326,   328,   330,   332,   334,   336,   338,   340,   343,   347,
     348,   350,   352,   354,   356,   359
};

/* YYRHS -- A `-1'-separated list of the rules' RHS.  */
static const yytype_int8 yyrhs[] =
{
      52,     0,    -1,    14,    50,    -1,    14,    36,    53,     8,
      54,    50,    -1,    14,    37,    53,    61,    -1,    14,    38,
      53,    -1,    14,    38,    39,    53,    -1,    14,    38,    40,
      56,    -1,    14,    38,    41,    56,    -1,    15,    50,    -1,
      16,    50,    -1,    16,    57,    50,    -1,    18,    50,    -1,
      18,    60,    50,    -1,    26,    50,    -1,    26,    57,    11,
      50,    -1,    27,    50,    -1,    27,    57,    50,    -1,    27,
      46,    58,    50,    -1,    19,    50,    -1,    19,    58,    50,
      -1,    19,    58,     5,    50,    -1,    19,    58,    62,    50,
      -1,    20,    50,    -1,    20,    58,    44,    50,    -1,    20,
      58,    45,    50,    -1,    20,    58,    42,     5,    50,    -1,
      20,    58,    43,     5,    50,    -1,    22,    50,    -1,    22,
      53,    50,    -1,    31,    50,    -1,    31,    59,    50,    -1,
      32,    50,    -1,    32,     8,    50,    -1,    33,    50,    -1,
      33,     8,    50,    -1,    34,    50,    -1,    34,     8,    50,
      -1,    29,    53,    50,    -1,    35,    50,    -1,    35,    55,
      50,    -1,    35,    55,    11,    50,    -1,    21,    50,    -1,
      21,    15,    50,    -1,    21,    23,    50,    -1,    21,    16,
      50,    -1,    21,    18,    50,    -1,    21,    17,    50,    -1,
      21,    27,    50,    -1,    21,    19,    50,    -1,    21,    29,
      50,    -1,    21,    14,    50,    -1,    21,    33,    50,    -1,
      21,    31,    50,    -1,    21,    32,    50,    -1,    21,    34,
      50,    -1,    21,    35,    50,    -1,    21,    20,    50,    -1,
      21,    24,    50,    -1,    21,    25,    50,    -1,    21,    26,
      50,    -1,    21,    28,    50,    -1,    21,    30,    50,    -1,
      21,    22,    50,    -1,    24,    50,    -1,    23,    50,    -1,
      23,    44,    50,    -1,    23,    45,    50,    -1,    23,    63,
      50,    -1,    25,    50,    -1,    28,    50,    -1,    28,    47,
      50,    -1,    28,    48,    50,    -1,    17,    50,    -1,    17,
      47,    50,    -1,    17,    48,    50,    -1,    30,    50,    -1,
      30,     5,    50,    -1,    50,    -1,    -1,     8,    -1,     9,
      -1,     5,    -1,    -1,     5,    -1,    11,    -1,     5,    -1,
      11,    -1,     5,    -1,     3,    -1,     4,    -1,     8,    -1,
       5,    -1,     6,    -1,     3,    -1,     4,    -1,    57,    -1,
      60,    57,    -1,    60,    12,    57,    -1,    -1,    11,    -1,
       8,    -1,     5,    -1,     8,    -1,     5,    63,    -1,     8,
      63,    -1
};

/* YYRLINE[YYN] -- source line where rule number YYN was defined.  */
static const yytype_uint16 yyrline[] =
{
       0,   133,   133,   137,   141,   145,   149,   153,   157,   161,
     164,   168,   172,   176,   179,   183,   188,   192,   197,   202,
     206,   212,   218,   224,   228,   238,   248,   259,   270,   274,
     278,   282,   286,   290,   294,   298,   302,   306,   310,   314,
     318,   323,   329,   333,   337,   341,   345,   349,   353,   357,
     361,   365,   369,   373,   377,   381,   385,   389,   393,   397,
     401,   405,   409,   413,   418,   419,   423,   427,   431,   435,
     438,   442,   445,   448,   452,   455,   458,   462,   465,   466,
     476,   477,   480,   481,   484,   493,   504,   505,   518,   530,
     544,   559,   574,   578,   582,   590,   599,   600,   601,   605,
     608,   609,   612,   613,   622,   623
};
#endif

#if YYDEBUG || YYERROR_VERBOSE || 0
/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "NUMBER2D", "NUMBER3D", "NUMBER",
  "NEGNUMBER", "FLAG", "NAME", "PATHNAME", "MACRO", "STRING", "COMMA",
  "EQUAL", "OPEN", "CLOSE", "DESC", "GETDESC", "FETCH", "INSTANCE",
  "PROFILE", "HELP", "WATCH", "DBG", "QUIT", "STATUS", "STORE", "INFO",
  "TIMER", "NAMESPACE", "WAIT", "PMNS_NAME", "PMNS_PMID", "PMNS_CHILDREN",
  "PMNS_TRAVERSE", "ATTR", "DSO", "PIPE", "SOCK", "UNIX", "INET", "IPV6",
  "ADD", "DEL", "ALL", "NONE", "INDOM", "ON", "OFF", "PLUS", "EOL",
  "$accept", "stmt", "fname", "optdomain", "attribute", "servport",
  "metric", "indom", "raw_pmid", "metriclist", "arglist", "inst", "debug", YY_NULL
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[YYLEX-NUM] -- Internal token number corresponding to
   token YYLEX-NUM.  */
static const yytype_uint16 yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305
};
# endif

/* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const yytype_uint8 yyr1[] =
{
       0,    51,    52,    52,    52,    52,    52,    52,    52,    52,
      52,    52,    52,    52,    52,    52,    52,    52,    52,    52,
      52,    52,    52,    52,    52,    52,    52,    52,    52,    52,
      52,    52,    52,    52,    52,    52,    52,    52,    52,    52,
      52,    52,    52,    52,    52,    52,    52,    52,    52,    52,
      52,    52,    52,    52,    52,    52,    52,    52,    52,    52,
      52,    52,    52,    52,    52,    52,    52,    52,    52,    52,
      52,    52,    52,    52,    52,    52,    52,    52,    52,    52,
      53,    53,    54,    54,    55,    55,    56,    56,    57,    57,
      57,    57,    58,    58,    58,    59,    60,    60,    60,    61,
      62,    62,    63,    63,    63,    63
};

/* YYR2[YYN] -- Number of symbols composing right hand side of rule YYN.  */
static const yytype_uint8 yyr2[] =
{
       0,     2,     2,     6,     4,     3,     4,     4,     4,     2,
       2,     3,     2,     3,     2,     4,     2,     3,     4,     2,
       3,     4,     4,     2,     4,     4,     5,     5,     2,     3,
       2,     3,     2,     3,     2,     3,     2,     3,     3,     2,
       3,     4,     2,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     2,     2,     3,     3,     3,     2,
       2,     3,     3,     2,     3,     3,     2,     3,     1,     0,
       1,     1,     1,     0,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     2,     3,     0,
       1,     1,     1,     1,     2,     2
};

/* YYDEFACT[STATE-NAME] -- Default reduction number in state STATE-NUM.
   Performed when YYTABLE doesn't specify something else to do.  Zero
   means the default is an error.  */
static const yytype_uint8 yydefact[] =
{
      79,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    78,     0,     0,     0,     0,     2,     9,
      89,    90,    88,    91,    10,     0,     0,     0,    73,    12,
      96,     0,    94,    92,    93,    19,     0,    23,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      42,    80,    81,    28,     0,   102,   103,     0,     0,    65,
       0,    64,    69,    14,     0,     0,    16,     0,     0,     0,
      70,     0,     0,    76,    95,    30,     0,     0,    32,     0,
      34,     0,    36,    84,    85,    39,     0,     1,     0,    99,
       0,     0,     0,     5,    11,    74,    75,     0,    13,    97,
       0,   101,   100,    20,     0,     0,     0,     0,     0,    51,
      43,    45,    47,    46,    49,    57,    63,    44,    58,    59,
      60,    48,    61,    50,    62,    53,    54,    52,    55,    56,
      29,   104,   105,    66,    67,    68,     0,     0,    17,    71,
      72,    38,    77,    31,    33,    35,    37,     0,    40,    83,
       4,     6,    86,    87,     7,     8,    98,    21,    22,     0,
       0,    24,    25,    15,    18,    41,    82,     0,    26,    27,
       3
};

/* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int16 yydefgoto[] =
{
      -1,    24,    74,   187,   106,   174,    35,    46,    96,    41,
     170,   124,    80
};

/* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
   STATE-NUM.  */
#define YYPACT_NINF -44
static const yytype_int16 yypact[] =
{
      99,    40,   -43,    22,    59,    29,    -1,    39,   128,    49,
      42,    -9,     5,    35,    10,   117,    55,    12,     2,    15,
      21,    23,    11,   -44,    46,    55,    55,    61,   -44,   -44,
     -44,   -44,   -44,   -44,   -44,    25,    34,    44,   -44,   -44,
     -44,    16,   -44,   -44,   -44,   -44,    43,   -44,    93,    47,
      60,    89,    90,    91,   116,   118,   119,   120,   121,   122,
     123,   124,   125,   126,   127,   129,   130,   131,   132,   133,
     -44,   -44,   -44,   -44,   134,    83,    83,   135,   136,   -44,
     137,   -44,   -44,   -44,    85,    77,   -44,   138,   139,   140,
     -44,   141,   142,   -44,   -44,   -44,   143,   144,   -44,   145,
     -44,   146,   -44,   -44,   -44,   -44,    24,   -44,   103,   -44,
      55,    48,    48,   -44,   -44,   -44,   -44,   100,   -44,   -44,
     147,   -44,   -44,   -44,   148,   194,   195,   151,   152,   -44,
     -44,   -44,   -44,   -44,   -44,   -44,   -44,   -44,   -44,   -44,
     -44,   -44,   -44,   -44,   -44,   -44,   -44,   -44,   -44,   -44,
     -44,   -44,   -44,   -44,   -44,   -44,   153,   154,   -44,   -44,
     -44,   -44,   -44,   -44,   -44,   -44,   -44,   155,   -44,   201,
     -44,   -44,   -44,   -44,   -44,   -44,   -44,   -44,   -44,   157,
     158,   -44,   -44,   -44,   -44,   -44,   -44,   159,   -44,   -44,
     -44
};

/* YYPGOTO[NTERM-NUM].  */
static const yytype_int8 yypgoto[] =
{
     -44,   -44,   -15,   -44,   -44,   -14,    -5,    -4,   -44,   -44,
     -44,   -44,    -8
};

/* YYTABLE[YYPACT[STATE-NUM]].  What to do in state STATE-NUM.  If
   positive, shift that token.  If negative, reduce the rule which
   number is the opposite.  If YYTABLE_NINF, syntax error.  */
#define YYTABLE_NINF -1
static const yytype_uint8 yytable[] =
{
      40,    91,    42,    48,    43,    44,    94,    29,    84,    87,
     108,   109,   113,    30,    31,    32,   103,    92,    33,    30,
      31,    32,   104,    97,    33,    30,    31,    32,   117,    99,
      33,   101,    30,    31,    32,   167,   119,    33,    30,    31,
      32,    81,    42,    33,    43,    44,   107,    75,   120,    45,
      76,   121,    95,   172,   122,    82,    85,    71,    72,   173,
      86,   105,    93,    71,    72,    98,   118,   151,   152,    71,
      72,   100,    34,   102,   168,   114,    25,    26,    27,    39,
      42,   157,    43,    44,   115,    83,    77,    78,    75,    47,
      28,    76,    79,   123,   116,   171,   156,   129,   175,    73,
     110,   111,   112,    30,    31,    32,    36,    37,    33,    38,
     130,   169,   176,     1,     2,     3,     4,     5,     6,     7,
       8,     9,    10,    11,    12,    13,    14,    15,    16,    17,
      18,    19,    20,    21,    22,   125,   126,   127,   128,   131,
     132,   133,    49,    50,    51,    52,    53,    54,    55,    23,
      56,    57,    58,    59,    60,    61,    62,    63,    64,    65,
      66,    67,    68,    69,    88,    89,   134,    90,   135,   136,
     137,   138,   139,   140,   141,   142,   143,   144,    70,   145,
     146,   147,   148,   149,   150,   153,   154,   155,   158,   159,
     160,   161,   162,   163,   164,   165,   166,   177,   178,   179,
     180,   181,   182,   183,   184,   185,   186,   188,   189,   190
};

#define yypact_value_is_default(Yystate) \
  (!!((Yystate) == (-44)))

#define yytable_value_is_error(Yytable_value) \
  YYID (0)

static const yytype_uint8 yycheck[] =
{
       5,    16,     3,     7,     5,     6,     4,    50,    13,    14,
      25,    26,    27,     3,     4,     5,     5,     5,     8,     3,
       4,     5,    11,     8,     8,     3,     4,     5,    12,     8,
       8,     8,     3,     4,     5,    11,    41,     8,     3,     4,
       5,    50,     3,     8,     5,     6,     0,     5,     5,    50,
       8,     8,    50,     5,    11,    50,    46,     8,     9,    11,
      50,    50,    50,     8,     9,    50,    50,    75,    76,     8,
       9,    50,    50,    50,    50,    50,    36,    37,    38,    50,
       3,    85,     5,     6,    50,    50,    44,    45,     5,    50,
      50,     8,    50,    50,    50,   110,    11,    50,   112,    50,
      39,    40,    41,     3,     4,     5,    47,    48,     8,    50,
      50,     8,   117,    14,    15,    16,    17,    18,    19,    20,
      21,    22,    23,    24,    25,    26,    27,    28,    29,    30,
      31,    32,    33,    34,    35,    42,    43,    44,    45,    50,
      50,    50,    14,    15,    16,    17,    18,    19,    20,    50,
      22,    23,    24,    25,    26,    27,    28,    29,    30,    31,
      32,    33,    34,    35,    47,    48,    50,    50,    50,    50,
      50,    50,    50,    50,    50,    50,    50,    50,    50,    50,
      50,    50,    50,    50,    50,    50,    50,    50,    50,    50,
      50,    50,    50,    50,    50,    50,    50,    50,    50,     5,
       5,    50,    50,    50,    50,    50,     5,    50,    50,    50
};

/* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
   symbol of state STATE-NUM.  */
static const yytype_uint8 yystos[] =
{
       0,    14,    15,    16,    17,    18,    19,    20,    21,    22,
      23,    24,    25,    26,    27,    28,    29,    30,    31,    32,
      33,    34,    35,    50,    52,    36,    37,    38,    50,    50,
       3,     4,     5,     8,    50,    57,    47,    48,    50,    50,
      57,    60,     3,     5,     6,    50,    58,    50,    58,    14,
      15,    16,    17,    18,    19,    20,    22,    23,    24,    25,
      26,    27,    28,    29,    30,    31,    32,    33,    34,    35,
      50,     8,     9,    50,    53,     5,     8,    44,    45,    50,
      63,    50,    50,    50,    57,    46,    50,    57,    47,    48,
      50,    53,     5,    50,     4,    50,    59,     8,    50,     8,
      50,     8,    50,     5,    11,    50,    55,     0,    53,    53,
      39,    40,    41,    53,    50,    50,    50,    12,    50,    57,
       5,     8,    11,    50,    62,    42,    43,    44,    45,    50,
      50,    50,    50,    50,    50,    50,    50,    50,    50,    50,
      50,    50,    50,    50,    50,    50,    50,    50,    50,    50,
      50,    63,    63,    50,    50,    50,    11,    58,    50,    50,
      50,    50,    50,    50,    50,    50,    50,    11,    50,     8,
      61,    53,     5,    11,    56,    56,    57,    50,    50,     5,
       5,    50,    50,    50,    50,    50,     5,    54,    50,    50,
      50
};

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		(-2)
#define YYEOF		0

#define YYACCEPT	goto yyacceptlab
#define YYABORT		goto yyabortlab
#define YYERROR		goto yyerrorlab


/* Like YYERROR except do call yyerror.  This remains here temporarily
   to ease the transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  However,
   YYFAIL appears to be in use.  Nevertheless, it is formally deprecated
   in Bison 2.4.2's NEWS entry, where a plan to phase it out is
   discussed.  */

#define YYFAIL		goto yyerrlab
#if defined YYFAIL
  /* This is here to suppress warnings from the GCC cpp's
     -Wunused-macros.  Normally we don't worry about that warning, but
     some users do, and we want to make it easy for users to remove
     YYFAIL uses, which will produce warnings from Bison 2.5.  */
#endif

#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)                                  \
do                                                              \
  if (yychar == YYEMPTY)                                        \
    {                                                           \
      yychar = (Token);                                         \
      yylval = (Value);                                         \
      YYPOPSTACK (yylen);                                       \
      yystate = *yyssp;                                         \
      goto yybackup;                                            \
    }                                                           \
  else                                                          \
    {                                                           \
      yyerror (YY_("syntax error: cannot back up")); \
      YYERROR;							\
    }								\
while (YYID (0))

/* Error token number */
#define YYTERROR	1
#define YYERRCODE	256


/* This macro is provided for backward compatibility. */
#ifndef YY_LOCATION_PRINT
# define YY_LOCATION_PRINT(File, Loc) ((void) 0)
#endif


/* YYLEX -- calling `yylex' with the right arguments.  */
#ifdef YYLEX_PARAM
# define YYLEX yylex (YYLEX_PARAM)
#else
# define YYLEX yylex ()
#endif

/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)			\
do {						\
  if (yydebug)					\
    YYFPRINTF Args;				\
} while (YYID (0))

# define YY_SYMBOL_PRINT(Title, Type, Value, Location)			  \
do {									  \
  if (yydebug)								  \
    {									  \
      YYFPRINTF (stderr, "%s ", Title);					  \
      yy_symbol_print (stderr,						  \
		  Type, Value); \
      YYFPRINTF (stderr, "\n");						  \
    }									  \
} while (YYID (0))


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

/*ARGSUSED*/
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_symbol_value_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep)
#else
static void
yy_symbol_value_print (yyoutput, yytype, yyvaluep)
    FILE *yyoutput;
    int yytype;
    YYSTYPE const * const yyvaluep;
#endif
{
  FILE *yyo = yyoutput;
  YYUSE (yyo);
  if (!yyvaluep)
    return;
# ifdef YYPRINT
  if (yytype < YYNTOKENS)
    YYPRINT (yyoutput, yytoknum[yytype], *yyvaluep);
# else
  YYUSE (yyoutput);
# endif
  switch (yytype)
    {
      default:
        break;
    }
}


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_symbol_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep)
#else
static void
yy_symbol_print (yyoutput, yytype, yyvaluep)
    FILE *yyoutput;
    int yytype;
    YYSTYPE const * const yyvaluep;
#endif
{
  if (yytype < YYNTOKENS)
    YYFPRINTF (yyoutput, "token %s (", yytname[yytype]);
  else
    YYFPRINTF (yyoutput, "nterm %s (", yytname[yytype]);

  yy_symbol_value_print (yyoutput, yytype, yyvaluep);
  YYFPRINTF (yyoutput, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_stack_print (yytype_int16 *yybottom, yytype_int16 *yytop)
#else
static void
yy_stack_print (yybottom, yytop)
    yytype_int16 *yybottom;
    yytype_int16 *yytop;
#endif
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)				\
do {								\
  if (yydebug)							\
    yy_stack_print ((Bottom), (Top));				\
} while (YYID (0))


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_reduce_print (YYSTYPE *yyvsp, int yyrule)
#else
static void
yy_reduce_print (yyvsp, yyrule)
    YYSTYPE *yyvsp;
    int yyrule;
#endif
{
  int yynrhs = yyr2[yyrule];
  int yyi;
  unsigned long int yylno = yyrline[yyrule];
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %lu):\n",
	     yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr, yyrhs[yyprhs[yyrule] + yyi],
		       &(yyvsp[(yyi + 1) - (yynrhs)])
		       		       );
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)		\
do {					\
  if (yydebug)				\
    yy_reduce_print (yyvsp, Rule); \
} while (YYID (0))

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YY_SYMBOL_PRINT(Title, Type, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef	YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif


#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined __GLIBC__ && defined _STRING_H
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static YYSIZE_T
yystrlen (const char *yystr)
#else
static YYSIZE_T
yystrlen (yystr)
    const char *yystr;
#endif
{
  YYSIZE_T yylen;
  for (yylen = 0; yystr[yylen]; yylen++)
    continue;
  return yylen;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined __GLIBC__ && defined _STRING_H && defined _GNU_SOURCE
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static char *
yystpcpy (char *yydest, const char *yysrc)
#else
static char *
yystpcpy (yydest, yysrc)
    char *yydest;
    const char *yysrc;
#endif
{
  char *yyd = yydest;
  const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

# ifndef yytnamerr
/* Copy to YYRES the contents of YYSTR after stripping away unnecessary
   quotes and backslashes, so that it's suitable for yyerror.  The
   heuristic is that double-quoting is unnecessary unless the string
   contains an apostrophe, a comma, or backslash (other than
   backslash-backslash).  YYSTR is taken from yytname.  If YYRES is
   null, do not copy; instead, return the length of what the result
   would have been.  */
static YYSIZE_T
yytnamerr (char *yyres, const char *yystr)
{
  if (*yystr == '"')
    {
      YYSIZE_T yyn = 0;
      char const *yyp = yystr;

      for (;;)
	switch (*++yyp)
	  {
	  case '\'':
	  case ',':
	    goto do_not_strip_quotes;

	  case '\\':
	    if (*++yyp != '\\')
	      goto do_not_strip_quotes;
	    /* Fall through.  */
	  default:
	    if (yyres)
	      yyres[yyn] = *yyp;
	    yyn++;
	    break;

	  case '"':
	    if (yyres)
	      yyres[yyn] = '\0';
	    return yyn;
	  }
    do_not_strip_quotes: ;
    }

  if (! yyres)
    return yystrlen (yystr);

  return yystpcpy (yyres, yystr) - yyres;
}
# endif

/* Copy into *YYMSG, which is of size *YYMSG_ALLOC, an error message
   about the unexpected token YYTOKEN for the state stack whose top is
   YYSSP.

   Return 0 if *YYMSG was successfully written.  Return 1 if *YYMSG is
   not large enough to hold the message.  In that case, also set
   *YYMSG_ALLOC to the required number of bytes.  Return 2 if the
   required number of bytes is too large to store.  */
static int
yysyntax_error (YYSIZE_T *yymsg_alloc, char **yymsg,
                yytype_int16 *yyssp, int yytoken)
{
  YYSIZE_T yysize0 = yytnamerr (YY_NULL, yytname[yytoken]);
  YYSIZE_T yysize = yysize0;
  enum { YYERROR_VERBOSE_ARGS_MAXIMUM = 5 };
  /* Internationalized format string. */
  const char *yyformat = YY_NULL;
  /* Arguments of yyformat. */
  char const *yyarg[YYERROR_VERBOSE_ARGS_MAXIMUM];
  /* Number of reported tokens (one for the "unexpected", one per
     "expected"). */
  int yycount = 0;

  /* There are many possibilities here to consider:
     - Assume YYFAIL is not used.  It's too flawed to consider.  See
       <http://lists.gnu.org/archive/html/bison-patches/2009-12/msg00024.html>
       for details.  YYERROR is fine as it does not invoke this
       function.
     - If this state is a consistent state with a default action, then
       the only way this function was invoked is if the default action
       is an error action.  In that case, don't check for expected
       tokens because there are none.
     - The only way there can be no lookahead present (in yychar) is if
       this state is a consistent state with a default action.  Thus,
       detecting the absence of a lookahead is sufficient to determine
       that there is no unexpected or expected token to report.  In that
       case, just report a simple "syntax error".
     - Don't assume there isn't a lookahead just because this state is a
       consistent state with a default action.  There might have been a
       previous inconsistent state, consistent state with a non-default
       action, or user semantic action that manipulated yychar.
     - Of course, the expected token list depends on states to have
       correct lookahead information, and it depends on the parser not
       to perform extra reductions after fetching a lookahead from the
       scanner and before detecting a syntax error.  Thus, state merging
       (from LALR or IELR) and default reductions corrupt the expected
       token list.  However, the list is correct for canonical LR with
       one exception: it will still contain any token that will not be
       accepted due to an error action in a later state.
  */
  if (yytoken != YYEMPTY)
    {
      int yyn = yypact[*yyssp];
      yyarg[yycount++] = yytname[yytoken];
      if (!yypact_value_is_default (yyn))
        {
          /* Start YYX at -YYN if negative to avoid negative indexes in
             YYCHECK.  In other words, skip the first -YYN actions for
             this state because they are default actions.  */
          int yyxbegin = yyn < 0 ? -yyn : 0;
          /* Stay within bounds of both yycheck and yytname.  */
          int yychecklim = YYLAST - yyn + 1;
          int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
          int yyx;

          for (yyx = yyxbegin; yyx < yyxend; ++yyx)
            if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR
                && !yytable_value_is_error (yytable[yyx + yyn]))
              {
                if (yycount == YYERROR_VERBOSE_ARGS_MAXIMUM)
                  {
                    yycount = 1;
                    yysize = yysize0;
                    break;
                  }
                yyarg[yycount++] = yytname[yyx];
                {
                  YYSIZE_T yysize1 = yysize + yytnamerr (YY_NULL, yytname[yyx]);
                  if (! (yysize <= yysize1
                         && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
                    return 2;
                  yysize = yysize1;
                }
              }
        }
    }

  switch (yycount)
    {
# define YYCASE_(N, S)                      \
      case N:                               \
        yyformat = S;                       \
      break
      YYCASE_(0, YY_("syntax error"));
      YYCASE_(1, YY_("syntax error, unexpected %s"));
      YYCASE_(2, YY_("syntax error, unexpected %s, expecting %s"));
      YYCASE_(3, YY_("syntax error, unexpected %s, expecting %s or %s"));
      YYCASE_(4, YY_("syntax error, unexpected %s, expecting %s or %s or %s"));
      YYCASE_(5, YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s"));
# undef YYCASE_
    }

  {
    YYSIZE_T yysize1 = yysize + yystrlen (yyformat);
    if (! (yysize <= yysize1 && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
      return 2;
    yysize = yysize1;
  }

  if (*yymsg_alloc < yysize)
    {
      *yymsg_alloc = 2 * yysize;
      if (! (yysize <= *yymsg_alloc
             && *yymsg_alloc <= YYSTACK_ALLOC_MAXIMUM))
        *yymsg_alloc = YYSTACK_ALLOC_MAXIMUM;
      return 1;
    }

  /* Avoid sprintf, as that infringes on the user's name space.
     Don't have undefined behavior even if the translation
     produced a string with the wrong number of "%s"s.  */
  {
    char *yyp = *yymsg;
    int yyi = 0;
    while ((*yyp = *yyformat) != '\0')
      if (*yyp == '%' && yyformat[1] == 's' && yyi < yycount)
        {
          yyp += yytnamerr (yyp, yyarg[yyi++]);
          yyformat += 2;
        }
      else
        {
          yyp++;
          yyformat++;
        }
  }
  return 0;
}
#endif /* YYERROR_VERBOSE */

/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

/*ARGSUSED*/
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yydestruct (const char *yymsg, int yytype, YYSTYPE *yyvaluep)
#else
static void
yydestruct (yymsg, yytype, yyvaluep)
    const char *yymsg;
    int yytype;
    YYSTYPE *yyvaluep;
#endif
{
  YYUSE (yyvaluep);

  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yytype, yyvaluep, yylocationp);

  switch (yytype)
    {

      default:
        break;
    }
}




/* The lookahead symbol.  */
int yychar;


#ifndef YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_END
#endif
#ifndef YY_INITIAL_VALUE
# define YY_INITIAL_VALUE(Value) /* Nothing. */
#endif

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval YY_INITIAL_VALUE(yyval_default);

/* Number of syntax errors so far.  */
int yynerrs;


/*----------.
| yyparse.  |
`----------*/

#ifdef YYPARSE_PARAM
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
int
yyparse (void *YYPARSE_PARAM)
#else
int
yyparse (YYPARSE_PARAM)
    void *YYPARSE_PARAM;
#endif
#else /* ! YYPARSE_PARAM */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
int
yyparse (void)
#else
int
yyparse ()

#endif
#endif
{
    int yystate;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus;

    /* The stacks and their tools:
       `yyss': related to states.
       `yyvs': related to semantic values.

       Refer to the stacks through separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* The state stack.  */
    yytype_int16 yyssa[YYINITDEPTH];
    yytype_int16 *yyss;
    yytype_int16 *yyssp;

    /* The semantic value stack.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs;
    YYSTYPE *yyvsp;

    YYSIZE_T yystacksize;

  int yyn;
  int yyresult;
  /* Lookahead token as an internal (translated) token number.  */
  int yytoken = 0;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;

#if YYERROR_VERBOSE
  /* Buffer for error messages, and its allocated size.  */
  char yymsgbuf[128];
  char *yymsg = yymsgbuf;
  YYSIZE_T yymsg_alloc = sizeof yymsgbuf;
#endif

#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  yyssp = yyss = yyssa;
  yyvsp = yyvs = yyvsa;
  yystacksize = YYINITDEPTH;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY; /* Cause a token to be read.  */
  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyss + yystacksize - 1 <= yyssp)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
	/* Give user a chance to reallocate the stack.  Use copies of
	   these so that the &'s don't force the real ones into
	   memory.  */
	YYSTYPE *yyvs1 = yyvs;
	yytype_int16 *yyss1 = yyss;

	/* Each stack pointer address is followed by the size of the
	   data in use in that stack, in bytes.  This used to be a
	   conditional around just the two extra args, but that might
	   be undefined if yyoverflow is a macro.  */
	yyoverflow (YY_("memory exhausted"),
		    &yyss1, yysize * sizeof (*yyssp),
		    &yyvs1, yysize * sizeof (*yyvsp),
		    &yystacksize);

	yyss = yyss1;
	yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyexhaustedlab;
# else
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
	goto yyexhaustedlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
	yystacksize = YYMAXDEPTH;

      {
	yytype_int16 *yyss1 = yyss;
	union yyalloc *yyptr =
	  (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
	if (! yyptr)
	  goto yyexhaustedlab;
	YYSTACK_RELOCATE (yyss_alloc, yyss);
	YYSTACK_RELOCATE (yyvs_alloc, yyvs);
#  undef YYSTACK_RELOCATE
	if (yyss1 != yyssa)
	  YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;

      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
		  (unsigned long int) yystacksize));

      if (yyss + yystacksize - 1 <= yyssp)
	YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;

/*-----------.
| yybackup.  |
`-----------*/
yybackup:

  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yypact_value_is_default (yyn))
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid lookahead symbol.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = YYLEX;
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yytable_value_is_error (yyn))
        goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);

  /* Discard the shifted token.  */
  yychar = YYEMPTY;

  yystate = yyn;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END

  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     `$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
        case 2:
/* Line 1792 of yacc.c  */
#line 133 "gram.y"
    {
		param.number = OPEN; param.pmid = HELP_USAGE;
		stmt_type = HELP; YYACCEPT;
	    }
    break;

  case 3:
/* Line 1792 of yacc.c  */
#line 137 "gram.y"
    {
		opendso((yyvsp[(3) - (6)].y_str), (yyvsp[(4) - (6)].y_str), (yyvsp[(5) - (6)].y_num));
		stmt_type = OPEN; YYACCEPT;
	    }
    break;

  case 4:
/* Line 1792 of yacc.c  */
#line 141 "gram.y"
    {
		openpmda((yyvsp[(3) - (4)].y_str));
		stmt_type = OPEN; YYACCEPT;
	    }
    break;

  case 5:
/* Line 1792 of yacc.c  */
#line 145 "gram.y"
    {
		open_unix_socket((yyvsp[(3) - (3)].y_str));
		stmt_type = OPEN; YYACCEPT;
	    }
    break;

  case 6:
/* Line 1792 of yacc.c  */
#line 149 "gram.y"
    {
		open_unix_socket((yyvsp[(4) - (4)].y_str));
		stmt_type = OPEN; YYACCEPT;
	    }
    break;

  case 7:
/* Line 1792 of yacc.c  */
#line 153 "gram.y"
    {
		open_inet_socket((yyvsp[(4) - (4)].y_num));
		stmt_type = OPEN; YYACCEPT;
	    }
    break;

  case 8:
/* Line 1792 of yacc.c  */
#line 157 "gram.y"
    {
		open_ipv6_socket((yyvsp[(4) - (4)].y_num));
		stmt_type = OPEN; YYACCEPT;
	    }
    break;

  case 9:
/* Line 1792 of yacc.c  */
#line 161 "gram.y"
    { 
		stmt_type = CLOSE; YYACCEPT; 
	    }
    break;

  case 10:
/* Line 1792 of yacc.c  */
#line 164 "gram.y"
    {
		param.number = DESC; param.pmid = HELP_USAGE;
		stmt_type = HELP; YYACCEPT;
	    }
    break;

  case 11:
/* Line 1792 of yacc.c  */
#line 168 "gram.y"
    {
		param.pmid = (yyvsp[(2) - (3)].y_num);
		stmt_type = DESC; YYACCEPT;
	    }
    break;

  case 12:
/* Line 1792 of yacc.c  */
#line 172 "gram.y"
    {
		param.number = FETCH; param.pmid = HELP_USAGE;
		stmt_type = HELP; YYACCEPT;
	    }
    break;

  case 13:
/* Line 1792 of yacc.c  */
#line 176 "gram.y"
    { 
		stmt_type = FETCH; YYACCEPT; 
	    }
    break;

  case 14:
/* Line 1792 of yacc.c  */
#line 179 "gram.y"
    {
		param.number = STORE; param.pmid = HELP_USAGE;
		stmt_type = HELP; YYACCEPT;
	    }
    break;

  case 15:
/* Line 1792 of yacc.c  */
#line 183 "gram.y"
    {
		param.name = (yyvsp[(3) - (4)].y_str);
		param.pmid = (pmID)(yyvsp[(2) - (4)].y_num);
		stmt_type = STORE; YYACCEPT;
	    }
    break;

  case 16:
/* Line 1792 of yacc.c  */
#line 188 "gram.y"
    {
		param.number = INFO; param.pmid = HELP_USAGE;
		stmt_type = HELP; YYACCEPT;
	    }
    break;

  case 17:
/* Line 1792 of yacc.c  */
#line 192 "gram.y"
    {
		param.number = PM_TEXT_PMID;
		param.pmid = (pmID)(yyvsp[(2) - (3)].y_num);
		stmt_type = INFO; YYACCEPT;
	    }
    break;

  case 18:
/* Line 1792 of yacc.c  */
#line 197 "gram.y"
    {
		param.number = PM_TEXT_INDOM;
		param.indom = indom.whole;
		stmt_type = INFO; YYACCEPT;
	    }
    break;

  case 19:
/* Line 1792 of yacc.c  */
#line 202 "gram.y"
    {
		param.number = INSTANCE; param.pmid = HELP_USAGE;
		stmt_type = HELP; YYACCEPT;
	    }
    break;

  case 20:
/* Line 1792 of yacc.c  */
#line 206 "gram.y"
    {
		param.indom = indom.whole;
		param.number = PM_IN_NULL;
		param.name = NULL;
		stmt_type = INSTANCE; YYACCEPT;
	    }
    break;

  case 21:
/* Line 1792 of yacc.c  */
#line 212 "gram.y"
    {
		param.indom = indom.whole;
		param.number = (yyvsp[(3) - (4)].y_num);
		param.name = NULL;
		stmt_type = INSTANCE; YYACCEPT;
	    }
    break;

  case 22:
/* Line 1792 of yacc.c  */
#line 218 "gram.y"
    {
		param.indom = indom.whole;
		param.number = PM_IN_NULL;
		param.name = (yyvsp[(3) - (4)].y_str);
		stmt_type = INSTANCE; YYACCEPT;
	    }
    break;

  case 23:
/* Line 1792 of yacc.c  */
#line 224 "gram.y"
    {
		param.number = PROFILE; param.pmid = HELP_USAGE;
		stmt_type = HELP; YYACCEPT;
	    }
    break;

  case 24:
/* Line 1792 of yacc.c  */
#line 228 "gram.y"
    {
		sts = pmAddProfile((yyvsp[(2) - (4)].y_num), 0, NULL);
		if (sts < 0) {
		    yyerror(pmErrStr(sts));
		    YYERROR;
		}
		profile_changed = 1;
		stmt_type = EOL;
		YYACCEPT;
	    }
    break;

  case 25:
/* Line 1792 of yacc.c  */
#line 238 "gram.y"
    {
		sts = pmDelProfile((yyvsp[(2) - (4)].y_num), 0, NULL);
		if (sts < 0) {
		    yyerror(pmErrStr(sts));
		    YYERROR;
		}
		profile_changed = 1;
		stmt_type = EOL;
		YYACCEPT;
	    }
    break;

  case 26:
/* Line 1792 of yacc.c  */
#line 248 "gram.y"
    {
		inst = (yyvsp[(4) - (5)].y_num);
		sts = pmAddProfile((yyvsp[(2) - (5)].y_num), 1, &inst);
		if (sts < 0) {
		    yyerror(pmErrStr(sts));
		    YYERROR;
		}
		profile_changed = 1;
		stmt_type = EOL;
		YYACCEPT;
	    }
    break;

  case 27:
/* Line 1792 of yacc.c  */
#line 259 "gram.y"
    {
		inst = (yyvsp[(4) - (5)].y_num);
		sts = pmDelProfile((yyvsp[(2) - (5)].y_num), 1, &inst);
		if (sts < 0) {
		    yyerror(pmErrStr(sts));
		    YYERROR;
		}
		profile_changed = 1;
		stmt_type = EOL;
		YYACCEPT;
	    }
    break;

  case 28:
/* Line 1792 of yacc.c  */
#line 270 "gram.y"
    {
		param.number = WATCH; param.pmid = HELP_USAGE;
		stmt_type = HELP; YYACCEPT;
	    }
    break;

  case 29:
/* Line 1792 of yacc.c  */
#line 274 "gram.y"
    {
		watch((yyvsp[(2) - (3)].y_str));
		stmt_type = WATCH; YYACCEPT;
	    }
    break;

  case 30:
/* Line 1792 of yacc.c  */
#line 278 "gram.y"
    {
		param.number = PMNS_NAME; param.pmid = HELP_USAGE;
		stmt_type = HELP; YYACCEPT;
	    }
    break;

  case 31:
/* Line 1792 of yacc.c  */
#line 282 "gram.y"
    {
		param.pmid = (yyvsp[(2) - (3)].y_num);
		stmt_type = PMNS_NAME; YYACCEPT;
	    }
    break;

  case 32:
/* Line 1792 of yacc.c  */
#line 286 "gram.y"
    {
		param.number = PMNS_PMID; param.pmid = HELP_USAGE;
		stmt_type = HELP; YYACCEPT;
	    }
    break;

  case 33:
/* Line 1792 of yacc.c  */
#line 290 "gram.y"
    {
		param.name = (yyvsp[(2) - (3)].y_str);
		stmt_type = PMNS_PMID; YYACCEPT;
	    }
    break;

  case 34:
/* Line 1792 of yacc.c  */
#line 294 "gram.y"
    {
		param.number = PMNS_CHILDREN; param.pmid = HELP_USAGE;
		stmt_type = HELP; YYACCEPT;
	    }
    break;

  case 35:
/* Line 1792 of yacc.c  */
#line 298 "gram.y"
    {
		param.name = (yyvsp[(2) - (3)].y_str);
		stmt_type = PMNS_CHILDREN; YYACCEPT;
	    }
    break;

  case 36:
/* Line 1792 of yacc.c  */
#line 302 "gram.y"
    {
		param.number = PMNS_TRAVERSE; param.pmid = HELP_USAGE;
		stmt_type = HELP; YYACCEPT;
	    }
    break;

  case 37:
/* Line 1792 of yacc.c  */
#line 306 "gram.y"
    {
		param.name = (yyvsp[(2) - (3)].y_str);
		stmt_type = PMNS_TRAVERSE; YYACCEPT;
	    }
    break;

  case 38:
/* Line 1792 of yacc.c  */
#line 310 "gram.y"
    {
		param.name = (yyvsp[(2) - (3)].y_str);
		stmt_type = NAMESPACE; YYACCEPT;
	    }
    break;

  case 39:
/* Line 1792 of yacc.c  */
#line 314 "gram.y"
    {
		param.number = ATTR; param.pmid = HELP_USAGE;
		stmt_type = HELP; YYACCEPT;
	    }
    break;

  case 40:
/* Line 1792 of yacc.c  */
#line 318 "gram.y"
    {
		param.number = (yyvsp[(2) - (3)].y_num);
		param.name = NULL;
		stmt_type = ATTR; YYACCEPT;
	    }
    break;

  case 41:
/* Line 1792 of yacc.c  */
#line 323 "gram.y"
    {
		param.number = (yyvsp[(2) - (4)].y_num);
		param.name = (yyvsp[(3) - (4)].y_str);
		stmt_type = ATTR; YYACCEPT;
	    }
    break;

  case 42:
/* Line 1792 of yacc.c  */
#line 329 "gram.y"
    { 
		param.number = -1; param.pmid = HELP_FULL; 
		stmt_type = HELP; YYACCEPT; 
	    }
    break;

  case 43:
/* Line 1792 of yacc.c  */
#line 333 "gram.y"
    {
		param.number = CLOSE; param.pmid = HELP_FULL; 
		stmt_type = HELP; YYACCEPT;
	    }
    break;

  case 44:
/* Line 1792 of yacc.c  */
#line 337 "gram.y"
    {
		param.number = DBG; param.pmid = HELP_FULL; 
		stmt_type = HELP; YYACCEPT;
	    }
    break;

  case 45:
/* Line 1792 of yacc.c  */
#line 341 "gram.y"
    {
		param.number = DESC; param.pmid = HELP_FULL; 
		stmt_type = HELP; YYACCEPT;
	    }
    break;

  case 46:
/* Line 1792 of yacc.c  */
#line 345 "gram.y"
    {
		param.number = FETCH; param.pmid = HELP_FULL; 
		stmt_type = HELP; YYACCEPT;
	    }
    break;

  case 47:
/* Line 1792 of yacc.c  */
#line 349 "gram.y"
    {
		param.number = GETDESC; param.pmid = HELP_FULL; 
		stmt_type = HELP; YYACCEPT;
	    }
    break;

  case 48:
/* Line 1792 of yacc.c  */
#line 353 "gram.y"
    {
		param.number = INFO; param.pmid = HELP_FULL;
		stmt_type = HELP; YYACCEPT;
	    }
    break;

  case 49:
/* Line 1792 of yacc.c  */
#line 357 "gram.y"
    {
		param.number = INSTANCE; param.pmid = HELP_FULL; 
		stmt_type = HELP; YYACCEPT;
	    }
    break;

  case 50:
/* Line 1792 of yacc.c  */
#line 361 "gram.y"
    {
		param.number = NAMESPACE; param.pmid = HELP_FULL; 
		stmt_type = HELP; YYACCEPT;
	    }
    break;

  case 51:
/* Line 1792 of yacc.c  */
#line 365 "gram.y"
    {
		param.number = OPEN; param.pmid = HELP_FULL; 
		stmt_type = HELP; YYACCEPT;
	    }
    break;

  case 52:
/* Line 1792 of yacc.c  */
#line 369 "gram.y"
    {
		param.number = PMNS_CHILDREN; param.pmid = HELP_FULL; 
		stmt_type = HELP; YYACCEPT;
	    }
    break;

  case 53:
/* Line 1792 of yacc.c  */
#line 373 "gram.y"
    {
		param.number = PMNS_NAME; param.pmid = HELP_FULL; 
		stmt_type = HELP; YYACCEPT;
	    }
    break;

  case 54:
/* Line 1792 of yacc.c  */
#line 377 "gram.y"
    {
		param.number = PMNS_PMID; param.pmid = HELP_FULL; 
		stmt_type = HELP; YYACCEPT;
	    }
    break;

  case 55:
/* Line 1792 of yacc.c  */
#line 381 "gram.y"
    {
		param.number = PMNS_TRAVERSE; param.pmid = HELP_FULL; 
		stmt_type = HELP; YYACCEPT;
	    }
    break;

  case 56:
/* Line 1792 of yacc.c  */
#line 385 "gram.y"
    {
		param.number = ATTR; param.pmid = HELP_FULL; 
		stmt_type = HELP; YYACCEPT;
	    }
    break;

  case 57:
/* Line 1792 of yacc.c  */
#line 389 "gram.y"
    {
		param.number = PROFILE; param.pmid = HELP_FULL; 
		stmt_type = HELP; YYACCEPT;
	    }
    break;

  case 58:
/* Line 1792 of yacc.c  */
#line 393 "gram.y"
    {
		param.number = QUIT; param.pmid = HELP_FULL; 
		stmt_type = HELP; YYACCEPT;
	    }
    break;

  case 59:
/* Line 1792 of yacc.c  */
#line 397 "gram.y"
    {
		param.number = STATUS; param.pmid = HELP_FULL; 
		stmt_type = HELP; YYACCEPT;
	    }
    break;

  case 60:
/* Line 1792 of yacc.c  */
#line 401 "gram.y"
    {
		param.number = STORE; param.pmid = HELP_FULL; 
		stmt_type = HELP; YYACCEPT;
	    }
    break;

  case 61:
/* Line 1792 of yacc.c  */
#line 405 "gram.y"
    {
		param.number = TIMER; param.pmid = HELP_FULL;
		stmt_type = HELP; YYACCEPT;
	    }
    break;

  case 62:
/* Line 1792 of yacc.c  */
#line 409 "gram.y"
    {
		param.number = WAIT; param.pmid = HELP_FULL;
		stmt_type = HELP; YYACCEPT;
	    }
    break;

  case 63:
/* Line 1792 of yacc.c  */
#line 413 "gram.y"
    {
		param.number = WATCH; param.pmid = HELP_FULL; 
		stmt_type = HELP; YYACCEPT;
	    }
    break;

  case 64:
/* Line 1792 of yacc.c  */
#line 418 "gram.y"
    { stmt_type = QUIT; YYACCEPT; }
    break;

  case 65:
/* Line 1792 of yacc.c  */
#line 419 "gram.y"
    {
		param.number = DBG; param.pmid = HELP_USAGE; 
		stmt_type = HELP; YYACCEPT;
	    }
    break;

  case 66:
/* Line 1792 of yacc.c  */
#line 423 "gram.y"
    {
		param.number = -1;
		stmt_type = DBG; YYACCEPT;
	    }
    break;

  case 67:
/* Line 1792 of yacc.c  */
#line 427 "gram.y"
    {
		param.number = 0;
		stmt_type = DBG; YYACCEPT;
	    }
    break;

  case 68:
/* Line 1792 of yacc.c  */
#line 431 "gram.y"
    {
		param.number = (yyvsp[(2) - (3)].y_num);
	        stmt_type = DBG; YYACCEPT;
	    }
    break;

  case 69:
/* Line 1792 of yacc.c  */
#line 435 "gram.y"
    { 
		stmt_type = STATUS; YYACCEPT; 
	    }
    break;

  case 70:
/* Line 1792 of yacc.c  */
#line 438 "gram.y"
    {
		param.number = TIMER; param.pmid = HELP_USAGE;
		stmt_type = HELP; YYACCEPT;
	    }
    break;

  case 71:
/* Line 1792 of yacc.c  */
#line 442 "gram.y"
    { 
		timer = 1; stmt_type = EOL; YYACCEPT; 
	    }
    break;

  case 72:
/* Line 1792 of yacc.c  */
#line 445 "gram.y"
    { 
		timer = 0; stmt_type = EOL; YYACCEPT; 
	    }
    break;

  case 73:
/* Line 1792 of yacc.c  */
#line 448 "gram.y"
    {
		param.number = GETDESC; param.pmid = HELP_USAGE;
		stmt_type = HELP; YYACCEPT;
	    }
    break;

  case 74:
/* Line 1792 of yacc.c  */
#line 452 "gram.y"
    { 
		get_desc = 1; stmt_type = EOL; YYACCEPT; 
	    }
    break;

  case 75:
/* Line 1792 of yacc.c  */
#line 455 "gram.y"
    { 
		get_desc = 0; stmt_type = EOL; YYACCEPT; 
	    }
    break;

  case 76:
/* Line 1792 of yacc.c  */
#line 458 "gram.y"
    {
		param.number = WAIT; param.pmid = HELP_USAGE;
		stmt_type = HELP; YYACCEPT;
	    }
    break;

  case 77:
/* Line 1792 of yacc.c  */
#line 462 "gram.y"
    { 
		stmt_type = EOL; sleep((yyvsp[(2) - (3)].y_num)); YYACCEPT;
	    }
    break;

  case 78:
/* Line 1792 of yacc.c  */
#line 465 "gram.y"
    { stmt_type = EOL; YYACCEPT; }
    break;

  case 79:
/* Line 1792 of yacc.c  */
#line 466 "gram.y"
    {
		if (yywrap())
		    YYACCEPT;
		else {
		    yyerror("Unrecognized command");
		    YYERROR;
		}
	    }
    break;

  case 80:
/* Line 1792 of yacc.c  */
#line 476 "gram.y"
    { (yyval.y_str) = strcons("./", (yyvsp[(1) - (1)].y_str)); }
    break;

  case 81:
/* Line 1792 of yacc.c  */
#line 477 "gram.y"
    { (yyval.y_str) = (yyvsp[(1) - (1)].y_str); }
    break;

  case 82:
/* Line 1792 of yacc.c  */
#line 480 "gram.y"
    { (yyval.y_num) = (yyvsp[(1) - (1)].y_num); }
    break;

  case 83:
/* Line 1792 of yacc.c  */
#line 481 "gram.y"
    { (yyval.y_num) = 0; }
    break;

  case 84:
/* Line 1792 of yacc.c  */
#line 484 "gram.y"
    {
		sts = __pmAttrKeyStr_r((yyvsp[(1) - (1)].y_num), warnStr, sizeof(warnStr));
		if (sts <= 0) {
		    sprintf(warnStr, "Attribute (%d) is not recognised", (yyvsp[(1) - (1)].y_num));
		    yyerror(warnStr);
		    YYERROR;
		}
		(yyval.y_num) = (yyvsp[(1) - (1)].y_num);
	    }
    break;

  case 85:
/* Line 1792 of yacc.c  */
#line 493 "gram.y"
    { 
		sts = __pmLookupAttrKey((yyvsp[(1) - (1)].y_str), strlen((yyvsp[(1) - (1)].y_str))+1);
		if (sts <= 0) {
		    sprintf(warnStr, "Attribute (%s) is not recognised", (yyvsp[(1) - (1)].y_str));
		    yyerror(warnStr);
		    YYERROR;
		}
		(yyval.y_num) = sts;
	    }
    break;

  case 86:
/* Line 1792 of yacc.c  */
#line 504 "gram.y"
    { (yyval.y_num) = (yyvsp[(1) - (1)].y_num); }
    break;

  case 87:
/* Line 1792 of yacc.c  */
#line 505 "gram.y"
    {
		struct servent *srv = getservbyname((yyvsp[(1) - (1)].y_str), NULL);
		if (srv == NULL) {
		    sprintf(warnStr, "Failed to map (%s) to a port number", (yyvsp[(1) - (1)].y_str));
		    yyerror(warnStr);
		    YYERROR;
		}
		sprintf(warnStr, "Mapped %s to port number %d", (yyvsp[(1) - (1)].y_str), srv->s_port);
		yywarn(warnStr);
		(yyval.y_num) = srv->s_port;
	    }
    break;

  case 88:
/* Line 1792 of yacc.c  */
#line 518 "gram.y"
    { 
		pmid.whole = (yyvsp[(1) - (1)].y_num);
		sts = pmNameID(pmid.whole, &str);
		if (sts < 0) {
		    sprintf(warnStr, "PMID (%s) is not defined in the PMNS",
			    pmIDStr(pmid.whole));
		    yywarn(warnStr);
		}
		else
		    free(str);
		(yyval.y_num) = (int)pmid.whole; 
	    }
    break;

  case 89:
/* Line 1792 of yacc.c  */
#line 530 "gram.y"
    {
		pmid.whole = 0;
		pmid.part.cluster = (yyvsp[(1) - (1)].y_2num).num1;
		pmid.part.item = (yyvsp[(1) - (1)].y_2num).num2;
		sts = pmNameID(pmid.whole, &str);
		if (sts < 0) {
		    sprintf(warnStr, "PMID (%s) is not defined in the PMNS",
			    pmIDStr(pmid.whole));
		    yywarn(warnStr);
		}
		else
		    free(str);
		(yyval.y_num) = (int)pmid.whole;
	    }
    break;

  case 90:
/* Line 1792 of yacc.c  */
#line 544 "gram.y"
    {
		pmid.whole = 0;
		pmid.part.domain = (yyvsp[(1) - (1)].y_3num).num1;
		pmid.part.cluster = (yyvsp[(1) - (1)].y_3num).num2;
		pmid.part.item = (yyvsp[(1) - (1)].y_3num).num3;
		sts = pmNameID(pmid.whole, &str);
		if (sts < 0) {
		    sprintf(warnStr, "PMID (%s) is not defined in the PMNS",
			    pmIDStr(pmid.whole));
		    yywarn(warnStr);
		}
		else
		    free(str);
		(yyval.y_num) = (int)pmid.whole;
	    }
    break;

  case 91:
/* Line 1792 of yacc.c  */
#line 559 "gram.y"
    {
		sts = pmLookupName(1, &(yyvsp[(1) - (1)].y_str), &pmid.whole);
		if (sts < 0) {
		    yyerror(pmErrStr(sts));
		    YYERROR;
		}
		sts = fix_dynamic_pmid((yyvsp[(1) - (1)].y_str), &pmid.whole);
		if (sts < 0) {
		    yyerror(pmErrStr(sts));
		    YYERROR;
		}
		(yyval.y_num) = (int)pmid.whole;
	    }
    break;

  case 92:
/* Line 1792 of yacc.c  */
#line 574 "gram.y"
    { 
		indom.whole = (yyvsp[(1) - (1)].y_num);
	        (yyval.y_num) = (int)indom.whole;
	    }
    break;

  case 93:
/* Line 1792 of yacc.c  */
#line 578 "gram.y"
    { 
		indom.whole = (yyvsp[(1) - (1)].y_num);
		(yyval.y_num) = (int)indom.whole;
	    }
    break;

  case 94:
/* Line 1792 of yacc.c  */
#line 582 "gram.y"
    {
		indom.whole = 0;
		indom.part.domain = (yyvsp[(1) - (1)].y_2num).num1;
		indom.part.serial = (yyvsp[(1) - (1)].y_2num).num2;
		(yyval.y_num) = (int)indom.whole;
	    }
    break;

  case 95:
/* Line 1792 of yacc.c  */
#line 590 "gram.y"
    {
		pmid.whole = 0;
		pmid.part.domain = (yyvsp[(1) - (1)].y_3num).num1;
		pmid.part.cluster = (yyvsp[(1) - (1)].y_3num).num2;
		pmid.part.item = (yyvsp[(1) - (1)].y_3num).num3;
		(yyval.y_num) = (int)pmid.whole;
	    }
    break;

  case 96:
/* Line 1792 of yacc.c  */
#line 599 "gram.y"
    { addmetriclist((pmID)(yyvsp[(1) - (1)].y_num)); }
    break;

  case 97:
/* Line 1792 of yacc.c  */
#line 600 "gram.y"
    { addmetriclist((pmID)(yyvsp[(2) - (2)].y_num)); }
    break;

  case 98:
/* Line 1792 of yacc.c  */
#line 601 "gram.y"
    { addmetriclist((pmID)(yyvsp[(3) - (3)].y_num)); }
    break;

  case 99:
/* Line 1792 of yacc.c  */
#line 605 "gram.y"
    { doargs(); }
    break;

  case 100:
/* Line 1792 of yacc.c  */
#line 608 "gram.y"
    { (yyval.y_str) = (yyvsp[(1) - (1)].y_str); }
    break;

  case 101:
/* Line 1792 of yacc.c  */
#line 609 "gram.y"
    { (yyval.y_str) = (yyvsp[(1) - (1)].y_str); }
    break;

  case 102:
/* Line 1792 of yacc.c  */
#line 612 "gram.y"
    { (yyval.y_num) = (yyvsp[(1) - (1)].y_num); }
    break;

  case 103:
/* Line 1792 of yacc.c  */
#line 613 "gram.y"
    {
			sts = __pmParseDebug((yyvsp[(1) - (1)].y_str));
			if (sts < 0) {
			    sprintf(warnStr, "Bad debug flag (%s)", (yyvsp[(1) - (1)].y_str));
			    yywarn(warnStr);
			    YYERROR;
			}
			(yyval.y_num) = sts;
		    }
    break;

  case 104:
/* Line 1792 of yacc.c  */
#line 622 "gram.y"
    { (yyval.y_num) = (yyvsp[(1) - (2)].y_num) | (yyvsp[(2) - (2)].y_num); }
    break;

  case 105:
/* Line 1792 of yacc.c  */
#line 623 "gram.y"
    {
			sts = __pmParseDebug((yyvsp[(1) - (2)].y_str));
			if (sts < 0) {
			    sprintf(warnStr, "Bad debug flag (%s)", (yyvsp[(1) - (2)].y_str));
			    yywarn(warnStr);
			    YYERROR;
			}
			(yyval.y_num) = sts | (yyvsp[(2) - (2)].y_num);
		    }
    break;


/* Line 1792 of yacc.c  */
#line 2677 "gram.tab.c"
      default: break;
    }
  /* User semantic actions sometimes alter yychar, and that requires
     that yytoken be updated with the new translation.  We take the
     approach of translating immediately before every use of yytoken.
     One alternative is translating here after every semantic action,
     but that translation would be missed if the semantic action invokes
     YYABORT, YYACCEPT, or YYERROR immediately after altering yychar or
     if it invokes YYBACKUP.  In the case of YYABORT or YYACCEPT, an
     incorrect destructor might then be invoked immediately.  In the
     case of YYERROR or YYBACKUP, subsequent parser actions might lead
     to an incorrect destructor call or verbose syntax error message
     before the lookahead is translated.  */
  YY_SYMBOL_PRINT ("-> $$ =", yyr1[yyn], &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);

  *++yyvsp = yyval;

  /* Now `shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTOKENS] + *yyssp;
  if (0 <= yystate && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTOKENS];

  goto yynewstate;


/*------------------------------------.
| yyerrlab -- here on detecting error |
`------------------------------------*/
yyerrlab:
  /* Make sure we have latest lookahead translation.  See comments at
     user semantic actions for why this is necessary.  */
  yytoken = yychar == YYEMPTY ? YYEMPTY : YYTRANSLATE (yychar);

  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if ! YYERROR_VERBOSE
      yyerror (YY_("syntax error"));
#else
# define YYSYNTAX_ERROR yysyntax_error (&yymsg_alloc, &yymsg, \
                                        yyssp, yytoken)
      {
        char const *yymsgp = YY_("syntax error");
        int yysyntax_error_status;
        yysyntax_error_status = YYSYNTAX_ERROR;
        if (yysyntax_error_status == 0)
          yymsgp = yymsg;
        else if (yysyntax_error_status == 1)
          {
            if (yymsg != yymsgbuf)
              YYSTACK_FREE (yymsg);
            yymsg = (char *) YYSTACK_ALLOC (yymsg_alloc);
            if (!yymsg)
              {
                yymsg = yymsgbuf;
                yymsg_alloc = sizeof yymsgbuf;
                yysyntax_error_status = 2;
              }
            else
              {
                yysyntax_error_status = YYSYNTAX_ERROR;
                yymsgp = yymsg;
              }
          }
        yyerror (yymsgp);
        if (yysyntax_error_status == 2)
          goto yyexhaustedlab;
      }
# undef YYSYNTAX_ERROR
#endif
    }



  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
	 error, discard it.  */

      if (yychar <= YYEOF)
	{
	  /* Return failure if at end of input.  */
	  if (yychar == YYEOF)
	    YYABORT;
	}
      else
	{
	  yydestruct ("Error: discarding",
		      yytoken, &yylval);
	  yychar = YYEMPTY;
	}
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:

  /* Pacify compilers like GCC when the user code never invokes
     YYERROR and the label yyerrorlab therefore never appears in user
     code.  */
  if (/*CONSTCOND*/ 0)
     goto yyerrorlab;

  /* Do not reclaim the symbols of the rule which action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;	/* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (!yypact_value_is_default (yyn))
	{
	  yyn += YYTERROR;
	  if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
	    {
	      yyn = yytable[yyn];
	      if (0 < yyn)
		break;
	    }
	}

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
	YYABORT;


      yydestruct ("Error: popping",
		  yystos[yystate], yyvsp);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END


  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", yystos[yyn], yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

#if !defined yyoverflow || YYERROR_VERBOSE
/*-------------------------------------------------.
| yyexhaustedlab -- memory exhaustion comes here.  |
`-------------------------------------------------*/
yyexhaustedlab:
  yyerror (YY_("memory exhausted"));
  yyresult = 2;
  /* Fall through.  */
#endif

yyreturn:
  if (yychar != YYEMPTY)
    {
      /* Make sure we have latest lookahead translation.  See comments at
         user semantic actions for why this is necessary.  */
      yytoken = YYTRANSLATE (yychar);
      yydestruct ("Cleanup: discarding lookahead",
                  yytoken, &yylval);
    }
  /* Do not reclaim the symbols of the rule which action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
		  yystos[*yyssp], yyvsp);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
#if YYERROR_VERBOSE
  if (yymsg != yymsgbuf)
    YYSTACK_FREE (yymsg);
#endif
  /* Make sure YYID is used.  */
  return YYID (yyresult);
}


/* Line 2055 of yacc.c  */
#line 634 "gram.y"

